<template>
	<Background :custom="true">
		<CardLayout>
			<template slot="head">
				<CommonHeader
					:title="category ? localizedCategoryName(category).toUpperCase() : $t('menu')"
				></CommonHeader>
			</template>
			<template slot="top">
				<div class="product-gallery">
					<Carousel
						v-if="product.photosURL && product.photosURL.length > 0 && product.photosURL[0] !== ''"
						:items="loadCarousel(product.photosURL)"
						:autoplaying="product.photosURL.length === 1 ? false : true"
					>
					</Carousel>
					<div v-else class="product-photo" :style="style"></div>
				</div>
			</template>
			<template slot="body">
				<div v-if="product" class="info" :class="{ 'no-order': !userCanOrder }">
					<div class="title-bar">
						<span>{{ localizedProductName(product).toUpperCase() }}</span>
					</div>
					<div class="title-desc">
						<span :set="(description = localizedProductDescription(product))" class="description-title">{{
							description ? $t('description') : ''
						}}</span>
						<p>{{ description }}</p>
					</div>
					<div class="title-desc" v-if="product.video" style="padding-bottom: 15px;">
						<a style="color: red; align-items: center; display: flex;" @click="showVideo = true">
							<img src="../assets/icons/video.svg" style="width: 25px;" />
							<span style="left: 5px; top: 1px; position: relative;">{{ $t('video') }}</span>
						</a>
					</div>
					<ul v-for="(ingredient, index) of ingredients" :key="index">
						<li class="block" v-if="ingredient.extraIngredients.length !== 0">
							<input type="checkbox" name="item" :id="index" checked />
							<label class="sub-colapse" :for="index">
								<i aria-hidden="true" class="icon-users"></i>
								{{ localizedIngredientName(ingredient) }}
								<span
									v-if="ingredient.required == true"
									:class="[changeReq ? 'IsRequired' : 'errNote']"
									>{{ $t('required') }}</span
								>
								<span class="icon">&#8249;</span>
								<br />
								<span v-if="ingredient.maxAmount > 0" :class="[changeNote ? 'note' : 'errNote']"
									>({{ $t('chooseTo') }} {{ ingredient.maxAmount }})</span
								>
							</label>
							<ul class="options">
								<div
									class="ingredient flex"
									v-for="(extraIngredient, index2) of ingredient.extraIngredients"
									:key="index2"
								>
									<div
										class="ingredients-container platillo-content"
										@click="status(extraIngredient.selected, index, ingredient.maxAmount, index2)"
									>
										<BeeCheckbox class="check-box" v-model="extraIngredient.selected"></BeeCheckbox>
										<span
											class="text-checks"
											@click="extraIngredient.selected = !extraIngredient.selected"
											>{{ localizedExtraIngredientName(extraIngredient) }}</span
										>
									</div>
									<div>{{ formatPrice(localizedExtraIngredientPrice(extraIngredient), true) }}</div>
								</div>
							</ul>
						</li>
					</ul>
					<ul>
						<textarea
							rows="4"
							v-if="userCanOrder"
							:placeholder="$t('additionalComment')"
							v-model="details"
							class="details"
						></textarea>
					</ul>
					<div class="add">
						<div class="botoneraitem">
							<CounterButton
								class="counter-button"
								v-if="userCanOrder"
								v-model="numberOfItems"
							></CounterButton>
						</div>
						<div class="botoneraitem botonera1">
							<BeeInput 
								v-if="userCanOrder" 
								@click="addProductToOrder()">
								<b>
									{{ `${$t('addOrder')} ${formatPrice(getPrice(), true)}`}}
								</b>
							</BeeInput>
						</div>
					</div>
				</div>
				<div v-else>
					<h1>Platillo no encontrado</h1>
				</div>
				<Modal class="modal" v-if="showVideo" @close="showVideo = false">
					<iframe width="100%" height="350" :src="videoUrl"> </iframe>
				</Modal>
				<!-- <MiniCart></MiniCart> -->
			</template>
		</CardLayout>
	</Background>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CardLayout from '@/layouts/CardLayout.vue'
import Background from '@/components/Background.vue'
import Next from '@/components/Next.vue'
import CounterButton from '@/components/CounterButton.vue'
import BeeInput from '@/components/BeeInput.vue'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import Product from '@/models/Product'
import Category from '@/models/Category'
import CommonHeader from '@/components/CommonHeader.vue'
import BeeCheckbox from '@/components/BeeCheckbox.vue'
import MiniCart from '@/components/MiniCart.vue'
import Ingredient from '@/models/Ingredient'
import Item from '@/models/Item'
import Modal from '@/components/Modal.vue'
import Carousel from '@/components/Carousel.vue'
import {
	localizedProductPrice,
	localizedProductName,
	localizedIngredientName,
	localizedExtraIngredientName,
	localizedExtraIngredientPrice
} from '../mixins/MenuLocalization'
import ItemIngredient from '../models/ItemIngredient'
import MenuService from '../services/MenuService'
import ItemExtraIngredient from '@/models/ItemExtraIngredient'
import { TypeOrder } from '@/store/state'
import Subcategory from '@/models/Subcategory'
import Price from '@/models/Price'

@Component({
	components: {
		Background,
		CardLayout,
		CommonHeader,
		Next,
		CounterButton,
		BeeInput,
		SpinnerHolder,
		BeeCheckbox,
		Modal,
		MiniCart,
		Carousel
	}
})
export default class Dish extends Vue {
	product: Product | null = null
	category: Category | null = null
	subCategory: Subcategory | null = null
	numberOfItems = 1
	userCanOrder = this.$store.getters.canOrder
	ingredients: Array<Ingredient> = []
	ingredientsResult = ''
	details = ''
	nIngredient: Array<number> = []
	changeNote = true
	changeReq = true
	showVideo = false
	videoUrl = ''
	price: Price | null = null

	loadCarousel(photosURL: Array<string>) {
		const items = photosURL.map(i => ({ url: i }))
		return items
	}

	status(check, grupo, maxi, index2) {
		if (maxi !== 0) {
			if (check == true) {
				if (this.nIngredient[grupo] <= maxi) {
					this.nIngredient[grupo]++
					this.ingredients[grupo].selected = true
				}
				if (this.nIngredient[grupo] > maxi) {
					this.ingredients[grupo].extraIngredients[index2].selected = false
					this.nIngredient[grupo]--
				}
			} else {
				this.nIngredient[grupo]--
				this.nIngredient[grupo] == 0 ? (this.ingredients[grupo].selected = false) : null
			}
		}
		if (maxi == 0) {
			check ? this.nIngredient[grupo]++ : this.nIngredient[grupo]--
			this.nIngredient[grupo] == 0
				? (this.ingredients[grupo].selected = false)
				: (this.ingredients[grupo].selected = true)
		}
	}

	getProduct(productId: string) {
		const products = this.$store.getters.products as Product[]
		const product = products.find(p => p.id == productId && localizedProductPrice(p))

		return product || null
	}

	getCategory(categoryId: string) {
		const categories = this.$store.getters.categories as Category[]
		const category = categories.find(c => c.id == categoryId)
		return category || null
	}

	getSubCategory(subCategoryId: string) {
		const subCategories = this.$store.getters.subcategories as Subcategory[]
		const subCategory = subCategories.find(c => c.id == subCategoryId)
		return subCategory || null
	}

	getPrice(){
		let extra = 0
		if(this.price){
			this.ingredients.map(i => {
				i.extraIngredients.map(e => {
					const extraPrice = localizedExtraIngredientPrice(e)
					if (extraPrice) {
						if (e.selected) {
							extra += extraPrice.ammount
						}
					}
				})
			})
			return this.numberOfItems * (this.price?.ammount + extra)
		}
	}

	addProductToOrder() {
		let error = 0
		this.ingredients.forEach((ing, index) => {
			if (ing.required) {
				let aux = 0
				ing.extraIngredients.forEach(extra => {
					if (extra.selected) aux++
				})
				if (aux == 0) {
					this.changeReq = false
					error += 1
				} else if (ing.maxAmount != 0) {
					if (this.nIngredient[index] > ing.maxAmount) {
						error += 1
						this.changeNote = false
					}
				}
			}
		})
		if (this.product && error == 0) {
			const item = new Item()
			const price = localizedProductPrice(this.product)
			let priceIngredients = 0

			item.id = this.product.id
			item.name = this.product.name
			if (this.category) {
				item.category = this.category.name
			}
			if (this.subCategory) {
				item.subcategory = this.subCategory.name
			}
			item.localizedName = localizedProductName(this.product)
			item.photoURL = this.product.photosURL[0]
			item.quantity = this.numberOfItems
			item.details = this.details
			if (price) {
				item.price = price
			}
			item.type = 'PRODUCT'
			item.ingredients = this.ingredients.map(i => {
				const itemIngredient = new ItemIngredient()
				itemIngredient.id = i.id
				itemIngredient.selected = i.selected
				itemIngredient.localizedNames = localizedIngredientName(i)
				itemIngredient.extraIngredients = i.extraIngredients.map(e => {
					const itemExtra = new ItemExtraIngredient()
					itemExtra.id = e.id
					itemExtra.selected = e.selected
					itemExtra.localizedNames = localizedExtraIngredientName(e)
					const extraPrice = localizedExtraIngredientPrice(e)
					if (extraPrice) {
						itemExtra.price = extraPrice
						if (itemExtra.selected) {
							priceIngredients += extraPrice.ammount
						}
					}
					return itemExtra
				})
				return itemIngredient
			})
			item.priceIngredients = priceIngredients
			this.$store.dispatch('addItemToOrder', item)
			this.nIngredient = this.nIngredient.fill(0)
			this.ingredients.forEach(ing => {
				ing.selected = false
				ing.extraIngredients.forEach(extra => {
					extra.selected = false
				})
			})
			this.$analytics.logEvent('add_to_cart', {
				id: this.product.id,
				value: price?.ammount,
				items: [
					{
						item_id: this.product.id,
						item_name: this.product.name,
						affiliation: this.$store.state.typeOrder,
						item_brand: this.$store.state.menu.name,
						item_category: this.category?.name,
						item_category2: this.subCategory?.name
					}
				],
				currency: price?.currency
			})
			this.$router.push('/menu')
		}
	}

	goBack() {
		history.back()
	}

	get style() {
		if (this.$store.state.customLogoURL) {
			return `background-image: url('${this.$store.state.customLogoURL}')`
		}
		return ''
	}

	created() {
		document.oncontextmenu = function() {
			return false
		}
		this.ingredients = this.$store.getters.ingredients(this.$route.params.productId) as Ingredient[]
		this.nIngredient = Array(this.ingredients.length).fill(0)
		this.product = this.getProduct(this.$route.params.productId)
		if (this.product) {
			this.category = this.getCategory(this.product.categoryId)
			if (this.product.subCategoryId) {
				this.subCategory = this.getSubCategory(this.product.subCategoryId)
			}
			MenuService.addViewToProduct(this.product.id, this.$store.state.typeOrder)
			if (this.product.video) this.videoUrl = this.product.video.replace('watch?v=', 'embed/')
			this.price = localizedProductPrice(this.product)
			this.$analytics.logEvent('view_item', {
				id: this.product.id,
				value: this.price?.ammount,
				items: [
					{
						item_id: this.product.id,
						item_name: this.product.name,
						affiliation: this.$store.state.typeOrder,
						item_brand: this.$store.state.menu.name,
						item_category: this.category?.name,
						item_category2: this.subCategory?.name
					}
				],
				currency: this.price?.currency
			})
		}
		if (this.$store.state.typeOrder != TypeOrder.LOCAL) {
			this.userCanOrder = true
		}
	}
}
</script>

<style lang="scss" scoped>
.product-gallery {
	height: 30vh;
	background-color: rgba($color: #000000, $alpha: 1);
	position: relative;

	.product-photo {
		max-width: 100%;
		height: 27vh;
		background-position: center;
		background-repeat: no-repeat;
		background-size: contain;
	}
}

.info {
	display: flex;
	flex-direction: column;
	justify-content: flex-start;
	min-height: 90%;

	.title-desc {
		padding: 10px;
	}

	.title-bar {
		display: flex;
		justify-content: space-between;
		align-items: center;
		font-weight: 700;
		font-size: 24px;
		padding: 10px;
		.price {
			float: right;
		}
	}

	.description-title {
		font-size: 10px;
	}

	// .counter-button {
	// 	margin-bottom: 4%;
	// }

	.details {
		font-family: 'Roboto condensed';
		width: 90%;
		border: transparent;
		border-bottom: #c0c0c0 2px solid;
		align-self: center;
		padding: 5px;
		margin: 20px auto 90px auto;
		display: flex;
	}

	.details:focus {
		outline: none;
	}

	.add {
		box-shadow: 0px 0px 10px rgb(110, 110, 110);
		border-radius: 10px 10px 0px 0px;
		position: fixed;
		margin: auto;
		left: 0;
		right: 0;
		bottom: 0;
		display: flex;
		background-color: #fff;
		padding: 0.5em 0.5em;
		.botoneraitem {
			width: 50%;
		}
		.botonera1 {
			margin-left: 5%;
			margin-right: 2.5%;
		}
	}
}

@media (min-width: 569px) {
	.add {
		width: 70%;
	}
}

@media (min-width: 1200px) {
	.add {
		width: 70%;
	}
}

.no-order {
	// background-color: black;
	justify-content: flex-start;

	// .title-bar {
	// 	margin-bottom: 00px;
	// }
}

.flex {
	display: flex;
	justify-content: space-between;
	align-items: center;
	width: 95%;
	padding: 0px 5px;
	margin-top: 3px;
}

.IsRequired {
	font-size: 0.7em;
	color: rgba(255, 0, 0, 0.377);
}

.note {
	font-size: 14px;
	color: #828282;
}

.errNote {
	font-size: 14px;
	color: red;
}

.options {
	.ingredient {
		display: flex;
		margin-bottom: 15px;
		padding: 15px;
		width: 100%;
		border-bottom: solid 2px rgb(192, 192, 192);
		border-radius: 5px;

		.ingredients-container {
			.text-checks {
				margin-left: 10px;
			}
		}
	}
}

* {
	-webkit-box-sizing: border-box;
	-moz-box-sizing: border-box;
	box-sizing: border-box;
}

ul {
	list-style: none;
	//margin:0;
	padding: 0;
	width: 100%;
	margin: 0 auto;
}

.options {
	height: 0;
	display: block;
	overflow: hidden;
	scroll-behavior: smooth;
}

.platillo-content {
	display: flex;
}

ul li label {
	color: rgb(0, 0, 0);
	font-weight: 600;
	.item-subtitle {
		color: brown;
		margin: 0px;
		font-weight: 400;
		font-size: 14px;
		color: #828282;
	}
}
ul li input[type='checkbox'] {
	display: none;
}
ul li label {
	display: block;
	padding: 12px;
	width: 100% !important;
}
ul li i {
	font-size: 18px;
	vertical-align: middle;
	width: 20px;
}
// Cerrado
ul li label {
	background: rgb(243, 243, 243);
}
// Cerrado subcolapse
ul li .sub-colapse {
	background: rgb(247, 247, 244);
}
// Abierto
ul li input[type='checkbox']:checked ~ label {
	background: rgb(235, 231, 231);
}

ul li input[type='checkbox']:checked ~ .sub-colapse {
	background: rgb(238, 237, 229);
}

ul li input[type='checkbox']:checked ~ .options {
	height: auto;
	display: block;
	min-height: 40px;
}
ul li label .icon {
	float: right;
	font-size: 25px;
	font-weight: 900;
	-webkit-transform: rotate(-90deg);
	-moz-transform: rotate(-90deg);
	-ms-transform: rotate(-90deg);
	-o-transform: rotate(-90deg);
	transform: rotate(-90deg);
	display: inline-block;
	vertical-align: middle;
}
ul li input[type='checkbox']:checked ~ label .icon {
	-webkit-transform: rotate(90deg);
	-moz-transform: rotate(90deg);
	-ms-transform: rotate(90deg);
	-o-transform: rotate(90deg);
	transform: rotate(90deg);
	display: inline-block;
}
ul ul {
	background: #fff;
	margin: 0;
	padding: 0;
}
ul ul li {
	border-bottom: 1px solid #ccc;
}
ul ul li:first-child {
	padding-top: 6px;
}
ul ul li:last-child {
	padding-bottom: 6px;
	border: 0;
}

//
</style>
